/* $Id: cut_down_congen_input.c 2736 2007-10-20 16:59:04Z flaterco $ */

/* Given the output of summarize and a matching congen input file, eliminate
   the constituents that have zero amplitude in the summary.
*/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#define linelen 1000

int main (int argc, char **argv) {
  int echo = 0;
  FILE *si, *ci;
  char sbuf[linelen], cbuf[linelen], name[linelen];
  double t;
  if (argc != 3) {
    fprintf (stderr, "Usage: cut_down_congen_input summary.txt congen_input.txt\n");
    exit (-1);
  }
  if (!(si = fopen (argv[1], "r"))) {
    perror (argv[1]);
    exit (-1);
  }
  if (!(ci = fopen (argv[2], "r"))) {
    perror (argv[2]);
    exit (-1);
  }
  while (fgets (sbuf, linelen, si)) {
    cbuf[0] = ' ';
    while (cbuf[0] == ' ') {
      cbuf[0] = '#';
      while (cbuf[0] == '#')
        assert (fgets (cbuf, linelen, ci));
      /* Handle trailing Doodson data from previous constituent */
      if (cbuf[0] == ' ') {
        if (echo)
          printf ("%s", cbuf);
      }
    }
    assert (sscanf (sbuf, "%s %lf", name, &t));
    if (t > 0.0) {
      printf ("%s", cbuf);
      echo = 1;
    } else echo = 0;
  }
  exit (0);
}
