/* $Id: summarize.c 2736 2007-10-20 16:59:04Z flaterco $ */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

/* summarize cons1.txt const2.txt ... (harmgen outputs)
   sums up the amplitudes to show which constituents are useless.
*/

/* HARD CODED ********/
#define numcsts 145
#define firstc "J1"

#define linelen 1000

int main (int argc, char **argv) {
  int i, j;
  double amps[numcsts], t;
  FILE *fp;
  char buf[linelen], *names[numcsts], name[linelen];
  for (i=0; i<numcsts; i++) {
    amps[i] = 0.0;
    names[i] = NULL;
  }
  for (i=1; i<argc; i++) {
    assert (fp = fopen (argv[i], "r"));
    do {
      assert (fgets (buf, linelen, fp));
    } while (strncmp (buf, firstc, strlen(firstc)));
    assert (sscanf (buf, "%s %lf", name, &t) == 2);
    amps[0] += t;
    if (names[0] == NULL)
      names[0] = strdup (name);
    for (j=1; j<numcsts; j++) {
      assert (fgets (buf, linelen, fp));
      assert (sscanf (buf, "%s %lf", name, &t) == 2);
      amps[j] += t;
      if (names[j] == NULL)
        names[j] = strdup (name);
    }
    fclose (fp);
  }
  for (i=0; i<numcsts; i++)
    printf ("%-10s %.4f\n", names[i], amps[i]);
  exit (0);
}
